<?php
/**
 * Plugin Name: Free SMS Sender to Pakistan
 * Plugin URI: http://www.codeproblem.com/plug-ins/86-free-sms-sender-to-pakistan-plugin-for-wordpress
 * Description: This plug-in can be used to send Free SMS messages to any mobile network of Pakistan, No need to setup a hardware, Just install this plug-in and you are ready.
 * Version: 1.0
 * Author: codeproblem.com
 * Author URI: http://www.codeproblem.com
 * License: GPL2 
 */

include_once dirname( __FILE__ ) . '/lib/captcha.php';
include_once dirname( __FILE__ ) . '/smsform.php';
include_once dirname( __FILE__ ) . '/pak-sms-sender-admin.php';

define("PAK_SMS_SENDER_VERSION", "1.0");

function paksmsinit()
{
	$smsSender = new SMSSender();
	$plugin_data = "";
	$plugin_data = $smsSender->notificationMessage();
	$plugin_data .= $smsSender->servicestatus();
	if(isset($_POST["sms_message"]))
	{
		$plugin_data .= $smsSender->processSMS();
	}
	$plugin_data .= $smsSender->generateSMSForm();
	return $plugin_data;
}

function pak_sms_css_js_scripts_include() {
		wp_enqueue_script('pak-sms-sender-script',plugins_url( '/js-min/script.js' , __FILE__ ),array( 'jquery' ));
	}
	
function register_session(){
		if( !session_id())
			session_start();
}
	
function pak_sms_parse_request($wp) {
		// only process requests with "pak-sms-sender=get-captcha"
		if (array_key_exists('pak-sms-sender', $wp->query_vars)
				&& $wp->query_vars['pak-sms-sender'] == 'get-captcha') {
	
			// process the request.
			$captcha = new Captcha();
			$captcha->getImage();
		}
	}

function pak_sms_query_vars($vars) {
		$vars[] = 'pak-sms-sender';
		return $vars;
}

function pak_sms_admin_menu(){
	add_options_page("Free SMS sender to Pakistan", "Pak SMS Sender", 'manage_options', 'pak-sms-sender-settings', 'pak_sms_sender_options');
}

function pak_sms_sender_options() {
	$admin = new PakSMSSenderAdministration();
	$admin->print_option_page();
}

function pak_sms_sender_register_options(){
	register_setting('paksmssenderog', 'pak_sms_sender_apikey' );
	register_setting('paksmssenderog', 'pak_sms_sender_registered_send');
	register_setting('paksmssenderog', 'pak_sms_sender_max_length');
	register_setting('paksmssenderog', 'pak_sms_sender_show_service_status');
}


//Add Filters
add_filter('query_vars', 'pak_sms_query_vars');

//Add actions
add_action('wp_enqueue_scripts', 'pak_sms_css_js_scripts_include');
add_action('parse_request', 'pak_sms_parse_request');
add_action('init','register_session');
if(is_admin())
{
	add_action('admin_menu', 'pak_sms_admin_menu');
	add_action('admin_init', 'pak_sms_sender_register_options');
}

//Add shortcode
add_shortcode('sms-sender-form', 'paksmsinit');
?>