<?php
class SMSSender
{
	var $end_point;
	var $sms_service_status;
	function __construct()
	{
		$this->end_point = "aHR0cDovL3d3dy5oYW1hcmFxdWV0dGEuY29tL3NlcnZpY2VzL3Ntc3NlcnZpY2UucGhwP2FjdGlvbj1wcm9jZXNzc21zcGx1Z2luZGF0YQ==";
		//get service status
		$data = array('command' => 'getservicestatus');
		$this->sms_service_status = $this->sendPostRequest($data);
	}
	
	/**
	 * This function will send a post request and receives the JSON data and decodes it before returning
	 * @param assossiative array $post_data
	 * @return JSON parsed object
	 */
	function sendPostRequest($post_data)
	{
		$ep = base64_decode($this->end_point);
		//dev//
		//$ep = "http://localhost/services/smsservice.php?action=processsmsplugindata";
		
		// use key 'http' even if you send the request to https://...
		$options = array(
				'http' => array(
						'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
						'method'  => 'POST',
						'content' => http_build_query($post_data),
				),
		);
		$context  = @stream_context_create($options);
		$result = @file_get_contents($ep, false, $context);
		return json_decode($result);
	}
	
	/**
	 * Processes an SMS
	 */
	function processSMS()
	{
		//verify code
		$code = strtolower($_POST["sms_seccode"]);
		if($code != strtolower($_SESSION["sms_image_code"]))
		{
			$process_code = "<div style='color: red; font-weight: bold;'>You have written wrong security code.</div>";
		}
		else
		{
			

			$client_ip = $_SERVER['REMOTE_ADDR'];
			$smsto = $_POST["sms_to_mprefix"].$_POST["sms_to_mnumber"];
			$api_key = get_option('pak_sms_sender_apikey'); //take it from admin settings
			$sms_max_length = get_option('pak_sms_sender_max_length',400);
			
			$site_url = get_option('siteurl');
			//dev//
			//$site_url = "http://www.eworld.pk/ew";
			
			$user_id = 0;
			if(is_user_logged_in())
			{
				$user = wp_get_current_user();
				$user_id = $user->ID;
			}
			
			if(!is_user_logged_in() && get_option('pak_sms_sender_registered_send',true) == true)
			{
				$process_code = "<div style='color: red; font-weight: bold;'>Only registered users can Send SMS</div>";
			}
			else
			{
				if($this->sms_service_status->status == 1)
				{
					//service is live
					$data = array('command' => 'sendsms', 'smsfrom' => $_POST["sms_from"], 'smsto' => $smsto, 'smstype' => $_POST["sms_type"], 'smsbody' => base64_encode($_POST["sms_message"]), 'smsclient_ip' => $client_ip, 'smssiteurl' => $site_url, 'smsuserid' => $user_id, 'smsmaxlength' => $sms_max_length, 'smsapi' => $api_key);
					
					$result_data = $this->sendPostRequest($data);
					
					if($result_data->code == 1)
					{
						$process_code = "<div style='color: green; font-weight: bold;'>SMS has been sent successfully!</div>";
					}
					else
					{
						$process_code = "<div style='color: red; font-weight: bold;'>".$result_data->error_description."</div>";
					}
				}
				else
				{
					//service is down
					$process_code = "<div style='color: red; font-weight: bold;'>SMS service is currently down, please try after some time.</div>";
				}
			}
			
		}
		return $process_code;
	}
	
	function generateSMSForm()
	{
		global $current_user;
		get_currentuserinfo();
		
		$form_code = "";
		
		if(!is_user_logged_in() && get_option('pak_sms_sender_registered_send',true) == true)
		{
			$form_code .= "<div style='color: red; font-weight: bold;'>You need to login to send an SMS.</div>";
		}
		
		$form_code .= "<h3>Fill out form to send free SMS</h3>
		<form method='post' id='pak_sms_form'>
		<table border='0'>
		<tr>
				<td><label for='sms_from'>From</label></td>
				<td><input type='text' name='sms_from' maxlength='15' value='".$current_user->display_name."'/></td>
		</tr>
		<tr>
				<td><label for='sms_to_mprefix'>Mobile Number</label></td>
				<td><select name=\"sms_to_mprefix\">
					<option value=\"0\">Select</option>
					<option value=\"0300\">0300</option>
					<option value=\"0301\">0301</option>
					<option value=\"0302\">0302</option>
					<option value=\"0303\">0303</option>
					<option value=\"0304\">0304</option>
					<option value=\"0305\">0305</option>
					<option value=\"0306\">0306</option>
					<option value=\"0307\">0307</option>
					<option value=\"0308\">0308</option>
					<option value=\"break\">-----</option>
					<option value=\"0311\">0311</option>
					<option value=\"0312\">0312</option>
					<option value=\"0313\">0313</option>
					<option value=\"0314\">0314</option>
					<option value=\"0315\">0315</option>
					<option value=\"0316\">0316</option>
					<option value=\"break\">-----</option>
					<option value=\"0321\">0321</option>
					<option value=\"0322\">0322</option>
					<option value=\"0323\">0323</option>
					<option value=\"0324\">0324</option>
					<option value=\"break\">-----</option>
					<option value=\"0331\">0331</option>
					<option value=\"0332\">0332</option>
					<option value=\"0333\">0333</option>
					<option value=\"0334\">0334</option>
					<option value=\"0335\">0335</option>
					<option value=\"0336\">0336</option>
					<option value=\"0337\">0337</option>
					<option value=\"break\">-----</option>
					<option value=\"0341\">0341</option>
					<option value=\"0342\">0342</option>
					<option value=\"0343\">0343</option>
					<option value=\"0344\">0344</option>
					<option value=\"0345\">0345</option>
					<option value=\"0346\">0346</option>
					<option value=\"0347\">0347</option>
				</select>&nbsp;<input type=\"text\" name=\"sms_to_mnumber\" maxlength=\"7\" style=\"width: 96px;\"></td>
			</tr>
			<tr>
				<td><label for='sms_type'>Type of SMS</label></td>
				<td><select name=\"sms_type\" title=\"Select type of SMS e.g. Flash or simple SMS\">
					<option value=\"simple\" title=\"Simple SMS\">Simple</option>
					<option value=\"flash\" title=\"Flash SMS is shown on mobile screen at once and may not be stored in inbox\">Flash</option>
				</select></td>
			</tr>
			<tr>
		<td></td>
		<td colspan=\"2\"><textarea id=\"message\" name=\"sms_message\" rows=\"8\" cols=\"38\" onblur=\"updateCharacterCount(null,'message','smscharcount',".get_option('pak_sms_sender_max_length',400).")\" onkeydown=\"updateCharacterCount(event,'message','smscharcount',".get_option('pak_sms_sender_max_length',400).")\"></textarea></td>
			</tr>
			<tr>
		<td></td>
		<td>
		<div style=\"height: 20px; position: relative; \">
		<div id=\"smscharcount\" style=\"display: none;\">500 characters left</div>
		</div>
		</td>
		<td></td>
	</tr>
		<tr>
		<td></td>
		<td><img src=\"".home_url()."/?pak-sms-sender=get-captcha\"></td>
		<td></td>
	</tr>
	<tr>
		<td><label for='sms_seccode'>Enter the above code here</label></td>
		<td><input type=\"text\" name=\"sms_seccode\" maxlength=\"5\" size=\"5\"></td>
		<td></td>
	</tr>
	<tr>
		<td></td>
		<td><input type=\"submit\" value=\"Send SMS\"></td>
			<td></td>
	</tr>
		</table></form>";
		return $form_code;
	}

	/**
	 * Prints the notification message
	 * @return string
	 */
	function notificationMessage()
	{
		$data = array('command' => 'gettopnotification');
		$result_data = $this->sendPostRequest($data);
		$process_code = "<div style='color: red; font-weight: bold;'>".$result_data->message."</div>";
		
		return $process_code;
	}
	
	/**
	 * Prints the service status panel
	 * @return string
	 */
	function servicestatus()
	{
		if(get_option('pak_sms_sender_show_service_status',false))
		{
			if($this->sms_service_status->status == 1)
			{
				$status = "<span style='color:green; font-weight: bold;'>Live</span>";
			}
			else
			{
				$status = "<span style='color:red; font-weight: bold;'>Down</span>";
			}
			$process_code = "<div>SMS Service status: $status</div>";
		}
		return $process_code;
	}
}
?>